ON = 1
OFF = 2
IDLE = 3

function init()
	buttonOn = FindShapes("soundOn")
	buttonOff = FindShapes("soundOff")
	speakers = FindShapes("speaker")
	
	for i=1, #buttonOn do
		SetTag(buttonOn[i], "interact", "ON")
		SetShapeEmissiveScale(buttonOn[i], 0)
	end
	for i=1, #buttonOff do
		SetTag(buttonOff[i], "interact", "OFF")
		SetShapeEmissiveScale(buttonOff[i], 0)
	end
	
	Pressed = false
	melody = LoadLoop("MOD/main/sound/departure_melodies/bell_B.ogg")
	ATOS = LoadSound("MOD/main/sound/ATOS.ogg")
	
	SetInt("level.depart", 0)
	SetInt("level.side", 2)
	
	approachTrigger = FindTrigger("approach")
	arriveTrigger = FindTrigger("arrive")
	
	Played = false
end

function isInArray(targetTable, value)
	for _, v in ipairs(targetTable) do
		if v == value then
			return true
		end
	end
	return false
end

function lightInit()
	for i=1, #buttonOn do
		SetShapeEmissiveScale(buttonOn[i], 0)
	end
	for i=1, #buttonOff do
		SetShapeEmissiveScale(buttonOff[i], 0)
	end
end

function update(dt)
	local loco = FindBody("loco", true)
	local locoVec = GetBodyTransform(loco)
	local locoPos = locoVec.pos
	if IsPointInTrigger(approachTrigger, locoPos) and not Played then
		for i=1, #speakers do
			local speakerPos = GetShapeWorldTransform(speakers[i])
			PlaySound(ATOS, speakerPos.pos)
			Played = true
		end
	elseif IsPointInTrigger(arriveTrigger, locoPos) then
		Played = false
	end
	
	if InputPressed("interact") then
		local handle = GetPlayerInteractShape()
		if isInArray(buttonOn, handle) then
			Pressed = ON
			SetInt("level.depart", 0)
		elseif isInArray(buttonOff, handle) then
			Pressed = OFF
			SetInt("level.depart", 1)
		end
	end
	
	if Pressed == ON then
		for i=1, #speakers do
			local speakerPos = GetShapeWorldTransform(speakers[i])
			PlayLoop(melody, speakerPos.pos)
		end
	end
end