MAX_SPEED = 25.5
DOOR_SPEED = 1
DOOR_STRENGTH = 1000

OPEN = 1
CLOSE = 2

L = 1
R = 2

CLOSE_THRESHOLD = 0.1

function init()
	bogies = FindShapes("bogie")
	doorsL = FindShapes("left")
	doorsR = FindShapes("right")
	
	bogieMotors = {}
	for i=1, #bogies do
		local joints = GetShapeJoints(bogies[i])
		for j=1, #joints do
			if HasTag(joints[j], "motor") then
				table.insert(bogieMotors, joints[j])
			end
		end
	end
	
	moveDoors(OPEN, R)
	moveDoors(CLOSE, L)
	
	speed = 0
	motorLoop = LoadLoop("MOD/main/sound/VVVF.ogg")
	motorAcc = LoadLoop("MOD/main/sound/accelerate.ogg")
	
	Played = false
	Closed = false
end

function moveDoors(dir, side)
	if dir == CLOSE then
		if side == L then
			for i=1, #doorsL do
				local doorMotor = GetShapeJoints(doorsL[i])
				for j=1, #doorMotor do
					local min, max = GetJointLimits(doorMotor[j])
					SetJointMotorTarget(doorMotor[j], min, DOOR_SPEED, DOOR_STRENGTH)
				end
			end
		elseif side == R then
			for i=1, #doorsR do
				local doorMotor = GetShapeJoints(doorsR[i])
				for j=1, #doorMotor do
					local min, max = GetJointLimits(doorMotor[j])
					SetJointMotorTarget(doorMotor[j], min, DOOR_SPEED, DOOR_STRENGTH)
				end
			end
		end
	elseif dir == OPEN then
		if side == L then
			for i=1, #doorsL do
				local doorMotor = GetShapeJoints(doorsL[i])
				for j=1, #doorMotor do
					local min, max = GetJointLimits(doorMotor[j])
					SetJointMotorTarget(doorMotor[j], max, DOOR_SPEED, DOOR_STRENGTH)
				end
			end
		elseif side == R then
			for i=1, #doorsR do
				local doorMotor = GetShapeJoints(doorsR[i])
				for j=1, #doorMotor do
					local min, max = GetJointLimits(doorMotor[j])
					SetJointMotorTarget(doorMotor[j], max, DOOR_SPEED, DOOR_STRENGTH)
				end
			end
		end
	end
end

function update(dt)
	local dep = GetInt("level.depart")
	local side = GetInt("level.side")
	if side == L then
		for i=1, #doorsL do
			local doorMotor = GetShapeJoints(doorsL[i])
			for j=1, #doorMotor do
				local stat = GetJointMovement(doorMotor[j])
				if stat < CLOSE_THRESHOLD then
					Closed = true
				else
					Closed = false
				end
			end
		end
	elseif side == R then
		for i=1, #doorsR do
			local doorMotor = GetShapeJoints(doorsR[i])
			for j=1, #doorMotor do
				local stat = GetJointMovement(doorMotor[j])
				if stat < CLOSE_THRESHOLD then
					Closed = true
				else
					Closed = false
				end
			end
		end
	end
	
	if dep == 1 then
		moveDoors(CLOSE, side)
		if Closed then
			for i=1, #bogies do
				local bogiePos = GetShapeWorldTransform(bogies[i])
				if speed < MAX_SPEED then
					PlayLoop(motorAcc, bogiePos.pos)
				else
					PlayLoop(motorLoop, bogiePos.pos)
				end
			end
			
			if speed < MAX_SPEED then
				speed = speed + dt*2
			else
				speed = MAX_SPEED
			end
			for i=1, #bogieMotors do
				SetJointMotor(bogieMotors[i], speed)
			end
		end
	elseif dep == 0 then
		moveDoors(OPEN, side)
	end
end